/******************************************************************************
			Euler's Method - Algorithm 5.1
*******************************************************************************

To approximate the solution of the initial-value problem
	y' = f(t,y),  a <= t <= b,  y(a) = alpha,
at (N+1) equally spaced numbers in the interval [a,b]:

INPUT endpoints a, b; integer N or interval h; initial condition alpha; the
function f():

OUTPUT approximation w to y at the (N+1) values of t.

*******************************************************************************
*	Written by:  Harold A. Toomey, BYU, Summer 1989, v4.11		      *
******************************************************************************/

#include <stdio.h>		/* for scanf() and printf() */
#include <math.h>		/* for math functions */
#include "naa_util.h"		/* Numerical Analysis Algorithms Utilities. */
#define	PI	3.14159265358979323846264338327950288419716939937510582097


main()
{
  double a, b, h=0.0, t, w, alpha, f();
  int i, N, ch, OK=0;

  get_title();

  printf("Euler's Method - Algorithm 5.1\n\n");
  fprintf(stderr, "Euler's Method - Algorithm 5.1\n\n");

  printf("y' = f(t,y) = -y + t + 1\n\n");
  /* Needs updating         $          */

  fprintf(stderr, "Enter endpoint a: ");
  scanf("%lf", &a);
  fprintf(stderr, "Enter endpoint b: ");
  scanf("%lf", &b);
  printf("Solving for points on interval [%lg,%lg].\n", a, b);

  fprintf(stderr, "Enter initial condition y(%lg) = alpha: ", a);
  scanf("%lf", &alpha);
  printf("y(%lg) = alpha = %lg\n", a, alpha);

  do {
    fprintf(stderr, "Do you want to enter N or h? ");
    ch = getchar();		/* Filters out Carriage Return/Linefeed. */
    ch = tolower(getchar());
    if (ch == 'n') {
      fprintf(stderr, "Enter number of subintervals N: ");
      scanf("%d", &N);
      h = (b-a)/N;
      OK = 1;
    }
    if (ch == 'h') {
      fprintf(stderr, "Enter interval number h: ");
      scanf("%lf", &h);
      N = (int) ceil((b-a)/h);
      OK = 1;
    }
    if (OK==0)
      fprintf(stderr, "\tTRY AGAIN.\n");
  } while (OK==0);

  printf("Number of subintervals N = %d\n", N);
  printf("Interval number h = %lg\n", h);

  /*-------------------------------------------------------------------------*/
  printf("\n t\t  w = y");	/* prints out table header */
  printf("\n------------------------\n");
  /*-------------------------------------------------------------------------*/

  /* STEP #1 */
  t = a;
  w = alpha;
  printf("% .2lf\t% .11lf\n", t, w);

  /* STEP #2 */
  for (i=1;i<=N;i++) {		/* Do Steps 3-4. */

    /* STEP #3 */
    w = w + h*f(t,w);		/* compute wi */
    t = a + i*h;		/* compute ti */

    /* STEP #4 */
    printf("% .2lf\t% .11lf\n", t, w);
  }

}  /* STEP #5 */		/* STOP */

/*****************************************************************************/
double f(t,y)		/* Function y' = f(t,y). */
double t, y;
{
  return (-y + t + 1);
}
/*****************************************************************************/
