/******************************************************************************
		Round() - Rounds X to SIG significant digits
******************************************************************************/
/* Requires #include <math.h> usually in the main program. */

/* Prototype. */
float round();

float round(X,SIG)
float X;
int SIG;			/* Number of significant digits */
{
  double y, rem;
  int i;

  if (X == 0.0)
    return (0.0);		/* Special case. */

  y = (double) X;

  for (i=0; fabs(y) > 1.0; i--)	/* Shift right to the decimal point. */
    y /= 10.0;
				/* Shift left SIG places. */
  while (fabs(y) <= fabs(pow(10.0, (double)(SIG - 1)))) {
    y *= 10.0;
    i++;
  }

  y = modf(y, &rem);		/* Returns fractional portion of y. */
  if (y >= 0.5)  y -= 1.0;	/* Rounds up if y >= 0.5. */
  if (y <= -0.5)  y += 1.0;	/* Rounds up if y <= -0.5. */
  rem = y / pow(10.0, (double) i);

  return(X - rem);
}

/******************************************************************************
*	Written by:  Harold A. Toomey, BYU, Summer 1989, v4.11		      *
******************************************************************************/
